#include <bits/stdc++.h>
#include "semia.h"
#include "spirit.h"
using namespace std;

vector< vector<int> > memo(200, vector<int>(200));
pair<int, int> pos_seeker;

int norm(pair<int, int> x) {
    return x.first * x.first + x.second * x.second;
}

pair<int, int> operator- (pair<int, int> u, pair<int, int> v) {
    return pair<int, int>(u.first - v.first, u.second - v.second);
}

inline int getInt(int l, int r, string flag = "(?)") {
    int x;
    if(!(cin >> x)) {
        cerr << "Failed to get " << flag << '\n';
        exit(1);
    }
    if(!(l <= x && x <= r)) {
        cerr << "Detected " << flag << " " << x << " violating the range [" << l << "," << r << "]\n";
        exit(1);
    }
    return x;
}

pair<int, int> Find(int x) {
    pair<int, int> ans(-1000, -1000);
    for(int i = 0; i < 200; i++) {
        for(int j = 0; j < 200; j++) {
            if(memo[i][j] != x) continue;
            if(norm(pos_seeker - ans) >= norm(pos_seeker - pair<int, int>(i, j))) {
                ans = pair<int, int>(i, j);
            }
        }
    }
    if(ans == pair<int, int>(-1000, -1000)) {
        cerr << "the number " << x << " was never written on the grid\n";
        exit(1);
    }
    return ans - pos_seeker;
}

int Get(int x, int y) {
    if(x < -1 || x > 1 || y < -1 || y > 1) {
        cerr << "Get query violates the permitted range\n";
        exit(1);
    }
    return memo[pos_seeker.first + x][pos_seeker.second + y];
}

int main() {
    int indicator;
    assert(cin >> indicator);
    if(50 <= indicator && indicator <= 149) { // spirit
        int pos_seeker_col = getInt(50, 149, "position of seeker");
        pos_seeker = pair<int, int>(indicator, pos_seeker_col);

        vector< pair<int, int> > pos_hider(9);
        for(int i = 0; i < 9; i++) {
            pos_hider[i].first = getInt(0, 199, "row of the position of a hider");
            pos_hider[i].second = getInt(0, 199, "col of the position of a hider");
        }
        vector<vector<int>> spirit_output = play_spirit(pos_hider);
        for(int i = 0; i < 200; i++) {
            for(int j = 0; j < 200; j++) {
                cout << spirit_output[i][j] << " \n"[j == 199];
            }
        }
        cout << pos_seeker.first << ' ' << pos_seeker.second << '\n';
    } else if(1 <= indicator && indicator <= 24) {
        for(int i = 0; i < 200; i++) {
            for(int j = 0; j < 200; j++) {
                if(i == 0 && j == 0) {
                    memo[i][j] = indicator;
                } else {
                    memo[i][j] = getInt(1, 24, "integer written by the spirit");
                }
            }
        }
        pos_seeker.first = getInt(50, 149, "row of the seeker");
        pos_seeker.second = getInt(50, 149, "col of the seeker");
        vector<int> semia_output = play_semia();
        for(int i = 0; i < 9; i++) cout << semia_output[i] << " \n"[i == 8];
        cout.flush();
    } else {
        cerr << "Invalid input\n";
        exit(1);
    }
}